=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module Pulp2to3MigrationClient
  class MigrationPlansApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a migration plan
    # MigrationPlan ViewSet.
    # @param pulp2to3_migration_migration_plan [Pulp2to3MigrationMigrationPlan] 
    # @param [Hash] opts the optional parameters
    # @return [Pulp2to3MigrationMigrationPlanResponse]
    def create(pulp2to3_migration_migration_plan, opts = {})
      data, _status_code, _headers = create_with_http_info(pulp2to3_migration_migration_plan, opts)
      data
    end

    # Create a migration plan
    # MigrationPlan ViewSet.
    # @param pulp2to3_migration_migration_plan [Pulp2to3MigrationMigrationPlan] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Pulp2to3MigrationMigrationPlanResponse, Integer, Hash)>] Pulp2to3MigrationMigrationPlanResponse data, response status code and response headers
    def create_with_http_info(pulp2to3_migration_migration_plan, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.create ...'
      end
      # verify the required parameter 'pulp2to3_migration_migration_plan' is set
      if @api_client.config.client_side_validation && pulp2to3_migration_migration_plan.nil?
        fail ArgumentError, "Missing the required parameter 'pulp2to3_migration_migration_plan' when calling MigrationPlansApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/migration-plans/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(pulp2to3_migration_migration_plan) 

      # return_type
      return_type = opts[:return_type] || 'Pulp2to3MigrationMigrationPlanResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a migration plan
    # MigrationPlan ViewSet.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(pulp_2to3_migration_migration_plan_href, opts = {})
      delete_with_http_info(pulp_2to3_migration_migration_plan_href, opts)
      nil
    end

    # Delete a migration plan
    # MigrationPlan ViewSet.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(pulp_2to3_migration_migration_plan_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.delete ...'
      end
      # verify the required parameter 'pulp_2to3_migration_migration_plan_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_migration_plan_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_migration_plan_href' when calling MigrationPlansApi.delete"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_migration_plan_href}'.sub('{' + 'pulp_2to3_migration_migration_plan_href' + '}', CGI.escape(pulp_2to3_migration_migration_plan_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List migration plans
    # MigrationPlan ViewSet.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Paginatedpulp2to3MigrationMigrationPlanResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List migration plans
    # MigrationPlan ViewSet.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Paginatedpulp2to3MigrationMigrationPlanResponseList, Integer, Hash)>] Paginatedpulp2to3MigrationMigrationPlanResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/migration-plans/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Paginatedpulp2to3MigrationMigrationPlanResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a migration plan
    # MigrationPlan ViewSet.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Pulp2to3MigrationMigrationPlanResponse]
    def read(pulp_2to3_migration_migration_plan_href, opts = {})
      data, _status_code, _headers = read_with_http_info(pulp_2to3_migration_migration_plan_href, opts)
      data
    end

    # Inspect a migration plan
    # MigrationPlan ViewSet.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Pulp2to3MigrationMigrationPlanResponse, Integer, Hash)>] Pulp2to3MigrationMigrationPlanResponse data, response status code and response headers
    def read_with_http_info(pulp_2to3_migration_migration_plan_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.read ...'
      end
      # verify the required parameter 'pulp_2to3_migration_migration_plan_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_migration_plan_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_migration_plan_href' when calling MigrationPlansApi.read"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_migration_plan_href}'.sub('{' + 'pulp_2to3_migration_migration_plan_href' + '}', CGI.escape(pulp_2to3_migration_migration_plan_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Pulp2to3MigrationMigrationPlanResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Reset Pulp 3 data for plugins specified in the migration plan
    # Trigger an asynchronous task to remove data from Pulp 3 related to the plugins specified in the migration plan.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def reset(pulp_2to3_migration_migration_plan_href, opts = {})
      data, _status_code, _headers = reset_with_http_info(pulp_2to3_migration_migration_plan_href, opts)
      data
    end

    # Reset Pulp 3 data for plugins specified in the migration plan
    # Trigger an asynchronous task to remove data from Pulp 3 related to the plugins specified in the migration plan.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def reset_with_http_info(pulp_2to3_migration_migration_plan_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.reset ...'
      end
      # verify the required parameter 'pulp_2to3_migration_migration_plan_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_migration_plan_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_migration_plan_href' when calling MigrationPlansApi.reset"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_migration_plan_href}reset/'.sub('{' + 'pulp_2to3_migration_migration_plan_href' + '}', CGI.escape(pulp_2to3_migration_migration_plan_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#reset\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Run migration plan
    # Trigger an asynchronous task to run a migration from Pulp 2.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param migration_plan_run [MigrationPlanRun] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def run(pulp_2to3_migration_migration_plan_href, migration_plan_run, opts = {})
      data, _status_code, _headers = run_with_http_info(pulp_2to3_migration_migration_plan_href, migration_plan_run, opts)
      data
    end

    # Run migration plan
    # Trigger an asynchronous task to run a migration from Pulp 2.
    # @param pulp_2to3_migration_migration_plan_href [String] 
    # @param migration_plan_run [MigrationPlanRun] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def run_with_http_info(pulp_2to3_migration_migration_plan_href, migration_plan_run, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MigrationPlansApi.run ...'
      end
      # verify the required parameter 'pulp_2to3_migration_migration_plan_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_migration_plan_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_migration_plan_href' when calling MigrationPlansApi.run"
      end
      # verify the required parameter 'migration_plan_run' is set
      if @api_client.config.client_side_validation && migration_plan_run.nil?
        fail ArgumentError, "Missing the required parameter 'migration_plan_run' when calling MigrationPlansApi.run"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_migration_plan_href}run/'.sub('{' + 'pulp_2to3_migration_migration_plan_href' + '}', CGI.escape(pulp_2to3_migration_migration_plan_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(migration_plan_run) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MigrationPlansApi#run\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
