=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module Pulp2to3MigrationClient
  class Pulp2ContentApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List pulp2 contents
    # ViewSet for Pulp2Content model.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp2_content_type_id 
    # @option opts [Array<String>] :pulp2_content_type_id__in Filter results where pulp2_content_type_id is in a comma-separated list of values
    # @option opts [String] :pulp2_id 
    # @option opts [Array<String>] :pulp2_id__in Filter results where pulp2_id is in a comma-separated list of values
    # @option opts [DateTime] :pulp2_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :pulp2_last_updated__gt Filter results where pulp2_last_updated is greater than value
    # @option opts [Integer] :pulp2_last_updated__gte Filter results where pulp2_last_updated is greater than or equal to value
    # @option opts [Integer] :pulp2_last_updated__lt Filter results where pulp2_last_updated is less than value
    # @option opts [Integer] :pulp2_last_updated__lte Filter results where pulp2_last_updated is less than or equal to value
    # @option opts [Array<Integer>] :pulp2_last_updated__range Filter results where pulp2_last_updated is between two comma separated values
    # @option opts [String] :pulp3_content Foreign Key referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Paginatedpulp2to3MigrationPulp2ContentResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List pulp2 contents
    # ViewSet for Pulp2Content model.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp2_content_type_id 
    # @option opts [Array<String>] :pulp2_content_type_id__in Filter results where pulp2_content_type_id is in a comma-separated list of values
    # @option opts [String] :pulp2_id 
    # @option opts [Array<String>] :pulp2_id__in Filter results where pulp2_id is in a comma-separated list of values
    # @option opts [DateTime] :pulp2_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :pulp2_last_updated__gt Filter results where pulp2_last_updated is greater than value
    # @option opts [Integer] :pulp2_last_updated__gte Filter results where pulp2_last_updated is greater than or equal to value
    # @option opts [Integer] :pulp2_last_updated__lt Filter results where pulp2_last_updated is less than value
    # @option opts [Integer] :pulp2_last_updated__lte Filter results where pulp2_last_updated is less than or equal to value
    # @option opts [Array<Integer>] :pulp2_last_updated__range Filter results where pulp2_last_updated is between two comma separated values
    # @option opts [String] :pulp3_content Foreign Key referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Paginatedpulp2to3MigrationPulp2ContentResponseList, Integer, Hash)>] Paginatedpulp2to3MigrationPulp2ContentResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: Pulp2ContentApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/pulp2content/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp2_content_type_id'] = opts[:'pulp2_content_type_id'] if !opts[:'pulp2_content_type_id'].nil?
      query_params[:'pulp2_content_type_id__in'] = @api_client.build_collection_param(opts[:'pulp2_content_type_id__in'], :csv) if !opts[:'pulp2_content_type_id__in'].nil?
      query_params[:'pulp2_id'] = opts[:'pulp2_id'] if !opts[:'pulp2_id'].nil?
      query_params[:'pulp2_id__in'] = @api_client.build_collection_param(opts[:'pulp2_id__in'], :csv) if !opts[:'pulp2_id__in'].nil?
      query_params[:'pulp2_last_updated'] = opts[:'pulp2_last_updated'] if !opts[:'pulp2_last_updated'].nil?
      query_params[:'pulp2_last_updated__gt'] = opts[:'pulp2_last_updated__gt'] if !opts[:'pulp2_last_updated__gt'].nil?
      query_params[:'pulp2_last_updated__gte'] = opts[:'pulp2_last_updated__gte'] if !opts[:'pulp2_last_updated__gte'].nil?
      query_params[:'pulp2_last_updated__lt'] = opts[:'pulp2_last_updated__lt'] if !opts[:'pulp2_last_updated__lt'].nil?
      query_params[:'pulp2_last_updated__lte'] = opts[:'pulp2_last_updated__lte'] if !opts[:'pulp2_last_updated__lte'].nil?
      query_params[:'pulp2_last_updated__range'] = @api_client.build_collection_param(opts[:'pulp2_last_updated__range'], :csv) if !opts[:'pulp2_last_updated__range'].nil?
      query_params[:'pulp3_content'] = opts[:'pulp3_content'] if !opts[:'pulp3_content'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Paginatedpulp2to3MigrationPulp2ContentResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: Pulp2ContentApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a pulp2 content
    # ViewSet for Pulp2Content model.
    # @param pulp_2to3_migration_pulp2_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Pulp2to3MigrationPulp2ContentResponse]
    def read(pulp_2to3_migration_pulp2_content_href, opts = {})
      data, _status_code, _headers = read_with_http_info(pulp_2to3_migration_pulp2_content_href, opts)
      data
    end

    # Inspect a pulp2 content
    # ViewSet for Pulp2Content model.
    # @param pulp_2to3_migration_pulp2_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Pulp2to3MigrationPulp2ContentResponse, Integer, Hash)>] Pulp2to3MigrationPulp2ContentResponse data, response status code and response headers
    def read_with_http_info(pulp_2to3_migration_pulp2_content_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: Pulp2ContentApi.read ...'
      end
      # verify the required parameter 'pulp_2to3_migration_pulp2_content_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_pulp2_content_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_pulp2_content_href' when calling Pulp2ContentApi.read"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_pulp2_content_href}'.sub('{' + 'pulp_2to3_migration_pulp2_content_href' + '}', CGI.escape(pulp_2to3_migration_pulp2_content_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Pulp2to3MigrationPulp2ContentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: Pulp2ContentApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
